SystemOrganization addCategory: #'NOCompletion-Model'!
SystemOrganization addCategory: #'NOCompletion-View'!

NECSelectorEntry subclass: #NOCDatedEntry
	instanceVariableNames: 'date next previous'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCDatedEntry commentStamp: '<historical>' prior: 0!
I keep a symbol entry, along with the last time it was used in the system. 
I am used to sort the possible answers.!

!NOCDatedEntry methodsFor: 'operations' stamp: 'rr 2/21/2009 11:49'!
<= anEntry
	^ date = anEntry date 
		ifTrue: [contents <= anEntry contents]
		ifFalse: [date > anEntry date]! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'rr 2/21/2009 11:49'!
date
	^ date! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'rr 4/9/2009 15:38'!
date: d
	date := d! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:12'!
link: anODatedEntry
	"Link the given entry after me."

	anODatedEntry
		next: next;
		previous: self.
	next previous: anODatedEntry.
	next := anODatedEntry! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:38'!
matches: pref

	^contents beginsWithEmpty: pref caseSensitive: false! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:07'!
next

	^next! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:08'!
next: anODatedEntry

	next := anODatedEntry! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'rr 4/9/2009 15:32'!
now
	date := DateAndTime now! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:07'!
previous

	^previous! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:08'!
previous: anODatedEntry

	previous := anODatedEntry! !

!NOCDatedEntry methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:08'!
unlink

	next previous: previous.
	previous next: next! !

NECMenuMorph subclass: #NOCMenuMorph
	instanceVariableNames: 'lastActivity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-View'!

!NOCMenuMorph commentStamp: '<historical>' prior: 0!
I am a morphic item used to show ocompletion entries. !

!NOCMenuMorph methodsFor: 'accessing' stamp: 'rr 4/15/2009 15:32'!
height
	^ 7! !

!NOCMenuMorph methodsFor: 'actions' stamp: 'rr 6/26/2009 11:33'!
narrowCompletion
	| model |
	
	self selected: 0.
	firstVisible := 1.
	model := context model.
	model narrowWith: context completionToken.
	model notEmpty ifTrue: [self selected: 1].
	model entries size < self selected ifTrue: [self selected: model entries size].
	self show.
	^ true! !

NECController subclass: #NOCController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCController commentStamp: '<historical>' prior: 0!
I am the entrance door to the ocompletion algorithm. 
I can resolve the queried sequences and retrieve a list of answers according to ocompletion algorithm based on the last accepted sequences from the user.
!

!NOCController class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 2/1/2013 18:12'!
initialize 
	self register.! !

!NOCController methodsFor: 'private' stamp: 'EstebanLorenzano 4/12/2012 11:17'!
contextClass
	^NOCContext! !

!NOCController methodsFor: 'private' stamp: 'CamilloBruni 8/5/2012 23:16'!
menuMorphClass
	^ NOCMenuMorph! !

NECUntypedModel subclass: #NOCModel
	instanceVariableNames: 'table expand context nextModel cachedEntries classTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCModel commentStamp: '<historical>' prior: 0!
I keep the state of the ocompletion algorithm. 
See comments of my parents for details. !

!NOCModel methodsFor: 'accessing' stamp: 'rr 5/28/2009 11:29'!
addEntry: ent
	(self tableForEntry: ent) addEntry: ent ! !

!NOCModel methodsFor: 'accessing' stamp: 'rr 4/14/2009 13:56'!
addSelectors
	! !

!NOCModel methodsFor: 'accessing' stamp: 'damiencassou 7/27/2009 14:22'!
at: aNumber
	
	^ self entries at: (aNumber max: 1) ! !

!NOCModel methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/1/2013 16:01'!
completionAt: aNumber
	"when an entry is selected, update its date (for inlined messages which do not appear in the method's body"
	| entry |
	
	entry := (self at: aNumber) completion.
	self addEntry: entry.
	
	^ NECPreferences spaceAfterCompletion 
		ifTrue: [ entry separateKeywords, ' ' ]
		ifFalse: [ entry separateKeywords ].! !

!NOCModel methodsFor: 'accessing' stamp: 'CamilloBruni 8/5/2012 23:55'!
context: aNOCContext
	context := aNOCContext.! !

!NOCModel methodsFor: 'accessing' stamp: 'CamilloBruni 8/5/2012 23:33'!
contract
	expand := true.
	nextModel := nil.! !

!NOCModel methodsFor: 'accessing' stamp: 'CamilloBruni 8/5/2012 23:35'!
entries
	| ent more |
	entries ifEmpty: [ self loadEntries ].
	^  entries! !

!NOCModel methodsFor: 'accessing' stamp: 'RomainRobbes 8/2/2010 17:56'!
entryCount
	^ self entries size! !

!NOCModel methodsFor: 'accessing' stamp: 'rr 4/15/2009 13:28'!
expand
	expand := true.! !

!NOCModel methodsFor: 'initialize-release' stamp: 'CamilloBruni 8/3/2012 21:26'!
initialize
	super initialize.
	self contract.
	table := NOCCompletionTable default.
	classTable := NOCCompletionTable classes.! !

!NOCModel methodsFor: 'initialize-release' stamp: 'rr 4/14/2009 13:56'!
initializeSelectors! !

!NOCModel methodsFor: 'private' stamp: 'CamilloBruni 8/7/2012 12:25'!
loadEntries
	| priorityEntries  |
	"entries used from the last recently used"
	priorityEntries := 6.
	self loadNextModelEntries.
	
	entries size <= priorityEntries
		ifTrue: [ ^ self ].
		
	"most recently used entries first!!"
	self sortByLastRecentlyUsed: self loadFavoredEntries.
		
	"sort the rest alphabetically"
	entries 
		mergeSortFrom: priorityEntries
		to: entries size 
		by: [ :a :b| 
			(a contents asString compare: b contents asString caseSensitive: false) <= 2 ]! !

!NOCModel methodsFor: 'private' stamp: 'CamilloBruni 8/7/2012 11:50'!
loadFavoredEntries
	
	(narrowString notEmpty and: [narrowString first isUppercase]) 
			ifTrue: [ ^ classTable entriesMatching: narrowString ].
					
	includeSelectors 
		ifTrue: [ ^ table entriesMatching: narrowString ]
		ifFalse: [ ^ #() ].! !

!NOCModel methodsFor: 'private' stamp: 'CamilloBruni 8/7/2012 11:51'!
loadNextModelEntries
	entries := self nextModel entries ! !

!NOCModel methodsFor: 'accessing' stamp: 'CamilloBruni 8/4/2012 00:52'!
narrowWith: aString
	self narrowString: aString.
	self loadEntries.
	self nextModel ifNotNilDo: [:nm | nm narrowWith: aString].! !

!NOCModel methodsFor: 'accessing' stamp: 'CamilloBruni 8/6/2012 12:58'!
nextModel
	^ nextModel ifNil: [
		nextModel := context nextModel. 
		nextModel narrowWith: narrowString.
		nextModel ].! !

!NOCModel methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/12/2012 11:20'!
noNextModel
	nextModel := NOCEmptyModel new.! !

!NOCModel methodsFor: 'private' stamp: 'CamilloBruni 8/7/2012 12:32'!
sortByLastRecentlyUsed: lastRecentlyUsedEntries
	"Sort my entrys by the most recently used date"
	| lastRecentlyUsed |
	
	lastRecentlyUsed := Dictionary new.
	
	lastRecentlyUsedEntries do: [ :entry|
		lastRecentlyUsed at: entry contents put: entry date asSeconds ].
	
	entries sort: [ :a :b|| dateA dateB|
		dateA := lastRecentlyUsed at: a contents asString ifAbsent: [ 0 ].
		dateB := lastRecentlyUsed at: b contents asString ifAbsent: [ 0 ].
		dateA >= dateB].! !

!NOCModel methodsFor: 'accessing' stamp: 'rr 4/14/2009 13:46'!
table
	^ table! !

!NOCModel methodsFor: 'accessing' stamp: 'CamilloBruni 8/3/2012 21:26'!
tableForEntry: ent
	^ (ent notEmpty and: [ent first isUppercase]) 
			ifTrue: [classTable]
			ifFalse: [table]! !

!NOCModel methodsFor: 'accessing' stamp: 'CamilloBruni 8/6/2012 00:01'!
title
	^ self nextModel title! !

!NOCModel methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/12/2012 11:17'!
useUniqueTable
	table := NOCCompletionTable new entriesPerPrefix: 20.
	! !

NECContext subclass: #NOCContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCContext commentStamp: '<historical>' prior: 0!
I keep the context of the ocompletion. 
I do the same as my parent but for this specific algorithm!

!NOCContext methodsFor: 'model creation' stamp: 'CamilloBruni 8/5/2012 23:55'!
createModel
	| aModel |
	
	aModel := NOCModel
		class: theClass
		temporaries: self temporaries
		additionals: controller additionals
		variables: variables
		selectors: selectors.
	aModel
		context: self.
		
	^ aModel ! !

!NOCContext methodsFor: 'model creation' stamp: 'EstebanLorenzano 2/1/2013 17:50'!
nextModel 
	"Provide a next lookup model. 
	 It is defining a chain of responsibility, translating the model to eCompletion, to ensure having results"
	^ super createModel! !

Object subclass: #NOCCompletionTable
	instanceVariableNames: 'table numberofEntries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

NOCCompletionTable class
	instanceVariableNames: 'classTable table'!

!NOCCompletionTable commentStamp: '<historical>' prior: 0!
I keep track of symbols to be retrieved in ocompletion algorithm. 
Unlike ecompletion, I learn something and try to retrieve users last occurences of typing sequences first, then the system symbols which match. 

TODO remove stupid symbols (like packages and method extensions and timestamp)!

NOCCompletionTable class
	instanceVariableNames: 'classTable table'!

!NOCCompletionTable class methodsFor: 'accessing' stamp: 'CamilloBruni 8/4/2012 01:05'!
classes
	^ classTable ifNil: [classTable := self new entriesPerPrefix: 40]! !

!NOCCompletionTable class methodsFor: 'cleanup' stamp: 'MarcusDenker 11/14/2012 13:37'!
cleanUp
	self reset.! !

!NOCCompletionTable class methodsFor: 'instance creation' stamp: 'rr 4/14/2009 17:13'!
default
	^ table ifNil: [table := self new entriesPerPrefix: 40]! !

!NOCCompletionTable class methodsFor: 'class initialization' stamp: 'MarcusDenker 11/14/2012 13:38'!
initialize
	SystemAnnouncer uniqueInstance 
		unsubscribe: self;
		on: MethodAdded, MethodModified 
			send: #methodChanged: 
			to: self.
	Smalltalk addToShutDownList: self.! !

!NOCCompletionTable class methodsFor: 'events' stamp: 'GuillermoPolito 8/3/2012 14:44'!
methodChanged: event
	self default totalNumberOfEntries < 200 ifTrue: [self default quickFillWithCategoryOf: event methodClass].
	self default totalNumberOfEntries < 500 ifTrue: [self default quickFillWithClass: event methodClass].
	self default justCompiled: event selector in: event methodClass.! !

!NOCCompletionTable class methodsFor: 'instance creation' stamp: 'MarcusDenker 11/14/2012 13:33'!
reset
	classTable := nil.
	table := nil.! !

!NOCCompletionTable class methodsFor: 'system startup' stamp: 'MarcusDenker 11/14/2012 13:39'!
shutDown
	self reset! !

!NOCCompletionTable methodsFor: 'protocol' stamp: 'rr 4/9/2009 17:55'!
addEntry: aString 
	| d |
	d := DateAndTime now.
	self 
		addEntry: aString
		date: d! !

!NOCCompletionTable methodsFor: 'protocol' stamp: 'rr 4/15/2009 10:52'!
addEntry: aString date: d 
	| lists |
	lists := self listsForPrefix: aString.
	lists do: [:e | e
		addEntry: aString
		date: d] ! !

!NOCCompletionTable methodsFor: 'protocol' stamp: 'ul 11/6/2010 06:35'!
compiled: selector in: class date: date

	| method |
	self addEntry: selector date: date.
	self class classes addEntry: class theNonMetaClass name date: date.
	(class canUnderstand: selector) ifFalse: [ ^self ].
	method := class compiledMethodAt: selector ifAbsent: [ ^self ].
	method messages do: [ :m | self  addEntry: m date: date ].
	method literals do: [ :each |
		(each isVariableBinding and: [
			each key notNil and: [
				each key first isUppercase ] ])
					ifTrue: [ 
						self class classes addEntry: each key date: date ] ]! !

!NOCCompletionTable methodsFor: 'accessing' stamp: 'rr 4/17/2009 14:14'!
entriesMatching: prefix
	| list |
	
	list := self listForPrefix: prefix.
	^ list entriesMatching: prefix! !

!NOCCompletionTable methodsFor: 'accessing' stamp: 'rr 4/9/2009 17:42'!
entriesPerPrefix: n
	numberofEntries := n! !

!NOCCompletionTable methodsFor: 'accessing' stamp: 'rr 4/10/2009 12:11'!
fillRate
	^ self totalNumberOfEntries / self maxNumberOfEntries ! !

!NOCCompletionTable methodsFor: 'initialization' stamp: 'rr 4/9/2009 17:45'!
initialize
	table := Dictionary new.! !

!NOCCompletionTable methodsFor: 'protocol' stamp: 'rr 4/16/2009 12:01'!
justCompiled: selector in: class 
	| date |
	date := DateAndTime now.
	self 
		compiled: selector
		in: class
		date: date! !

!NOCCompletionTable methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/12/2012 11:20'!
listForPrefix: aString 
	| prefix |
	aString isEmpty ifTrue: [^ NOCEntryList ofSize: numberofEntries].
	prefix := aString size = 1 
			ifTrue: [ aString first asLowercase asString] 
			ifFalse: [(aString first: 2) collect: [:e | e asLowercase]].
			
	^ table 
		at: prefix
		ifAbsentPut: [ NOCEntryList ofSize: numberofEntries ]! !

!NOCCompletionTable methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/12/2012 11:20'!
listsForPrefix: aString 
	|  prefixes |
	aString isEmpty ifTrue: [^ Array with: (NOCEntryList ofSize: numberofEntries)].
	prefixes := OrderedCollection with: aString first asLowercase asString.
	 
	aString size > 1 
			ifTrue: [prefixes add: ((aString first: 2) collect: [:e | e asLowercase])].
	^ prefixes collect: [:prefix | table 
		at: prefix
		ifAbsentPut: [ NOCEntryList ofSize: numberofEntries ]]! !

!NOCCompletionTable methodsFor: 'accessing' stamp: 'rr 4/10/2009 12:10'!
maxNumberOfEntries
	^ 26 * 26 * numberofEntries ! !

!NOCCompletionTable methodsFor: 'accessing' stamp: 'rr 4/9/2009 17:46'!
numberOfEntries
	^ numberofEntries! !

!NOCCompletionTable methodsFor: 'protocol' stamp: 'MarcusDenker 7/15/2012 13:48'!
quickFillWithCategoriesMatching: pattern
	(Smalltalk organization categoriesMatching: pattern) do: [:category | 
		(Smalltalk organization classesInCategory: category) do: [:e | self quickFillWithClass: e]]! !

!NOCCompletionTable methodsFor: 'protocol' stamp: 'MarcusDenker 7/15/2012 13:47'!
quickFillWithCategoryOf: cls
	(Smalltalk organization classesInCategory: cls theNonMetaClass category) do: [:e | self quickFillWithClass: e]! !

!NOCCompletionTable methodsFor: 'protocol' stamp: 'rr 5/28/2009 14:10'!
quickFillWithClass: cls
	cls methodsDo: [:e | self justCompiled: e selector in: cls]
	! !

!NOCCompletionTable methodsFor: 'accessing' stamp: 'rr 4/10/2009 11:21'!
reset
	table := Dictionary new.! !

!NOCCompletionTable methodsFor: 'accessing' stamp: 'rr 4/9/2009 17:49'!
totalNumberOfEntries
	^ table inject: 0 into: [:total :list | total + list numEntries]! !

Object subclass: #NOCEmptyModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCEmptyModel commentStamp: '<historical>' prior: 0!
I implement a null object pattern related to NOCModel in order to mark the end of possible completions in the answer list. 

!

!NOCEmptyModel methodsFor: 'accessing' stamp: 'rr 4/14/2009 16:47'!
entries
	^ Array new! !

!NOCEmptyModel methodsFor: 'accessing' stamp: 'rr 4/17/2009 14:27'!
entryCount 
	^ 0! !

!NOCEmptyModel methodsFor: 'accessing' stamp: 'rr 4/17/2009 14:26'!
narrowString: string! !

!NOCEmptyModel methodsFor: 'accessing' stamp: 'rr 4/17/2009 14:26'!
narrowWith: string 
! !

Object subclass: #NOCEntryList
	instanceVariableNames: 'size entries entryHead'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCEntryList commentStamp: '<historical>' prior: 0!
I am the list of entries (possible symbols) returned by nocompletion algorithm.

I am sorted according to last acceptance from the user.!

!NOCEntryList class methodsFor: 'instance creation' stamp: 'rr 2/21/2009 11:44'!
ofSize: n 
	^ self new setSize: n; yourself! !

!NOCEntryList methodsFor: 'adding' stamp: 'rr 4/9/2009 16:06'!
addEntry: aSymbol
	self addEntry: aSymbol date: DateAndTime now! !

!NOCEntryList methodsFor: 'adding' stamp: 'EstebanLorenzano 4/12/2012 11:21'!
addEntry: aSymbol date: aDate

	| entry currentEntry |
	entry := entries at: aSymbol ifAbsent: nil.
	entry 
		ifNotNil: [ entry unlink ]
		ifNil: [ 
			entry := NOCDatedEntry contents: aSymbol type: #selector.
			entries at: aSymbol put: entry ].
	entry date: aDate.
	currentEntry := entryHead previous.
	[ currentEntry == entryHead or: [
		currentEntry date <= aDate ] ] whileFalse: [
			currentEntry := currentEntry previous ].
	currentEntry link: entry.
	entries size > size ifTrue: [
		entry := entryHead next unlink.
		entries removeKey: entry contents ]! !

!NOCEntryList methodsFor: 'accessing' stamp: 'ul 9/29/2010 18:56'!
entriesMatching: prefix
	
	^Array new: entries size // 4 + 1 streamContents: [ :stream |
		| entry |
		entry := self firstEntry.
		[ entry == entryHead ] whileFalse: [
			(entry matches: prefix) ifTrue: [ stream nextPut: entry ].
			entry := entry previous ] ]! !

!NOCEntryList methodsFor: 'accessing' stamp: 'rr 4/9/2009 16:14'!
first
	^self firstEntry contents! !

!NOCEntryList methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:31'!
firstEntry
	^ entryHead previous! !

!NOCEntryList methodsFor: 'accessing' stamp: 'rr 4/9/2009 16:14'!
last
	^self lastEntry contents! !

!NOCEntryList methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:31'!
lastEntry
	^ entryHead next! !

!NOCEntryList methodsFor: 'accessing' stamp: 'rr 2/21/2009 11:46'!
numEntries
	^ entries size! !

!NOCEntryList methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/12/2012 11:21'!
setSize: n
	size := n.
	entries := Dictionary new: n.
	entryHead := NOCDatedEntry contents: #'' size type: #selector.
	entryHead
		next: entryHead;
		previous: entryHead.
	
	! !
NOCCompletionTable initialize!
NOCController initialize!
